﻿package
{
	
	import flash.display.*;
	import flash.events.*;
	import flash.utils.*;
	import flash.filters.*;
	import flash.text.*;
	import flash.system.*;
	import fl.transitions.*;
	import fl.transitions.easing.*;
	import com.potix2.utils.GCWatcher;
	
	public class Main extends Sprite
	{
		static private const TIMER_INTERVAL:int = 200;
		private var _timer:Timer;
		private var watcher:GCWatcher;
		
		public function Main()
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			watcher = new GCWatcher(100);
			watcher.addEventListener(Event.CHANGE, onChange);
			watcher.addEventListener(GCWatcher.GARBAGE_COLLECT, onGarbageCollect);
			
			_timer = new Timer(TIMER_INTERVAL);
			_timer.addEventListener(TimerEvent.TIMER, timerHandler);
			_timer.start();
			
			gcBtn.addEventListener(MouseEvent.CLICK, clickHandler);
		}
		
		private function timerHandler(event:TimerEvent):void
		{
			var snow:Sprite = new Snow();
			snow.x = stage.stageWidth * Math.random();
			
			var size:Number = Math.random();
			var blur:int = Math.floor(size * 4) * 4;
			var time:Number = 3 * (1 - size) + 2;
			
			snow.scaleX = snow.scaleY = size;
			snow.filters = [new BlurFilter(blur, blur, 2)];
			snow.blendMode = BlendMode.ADD;
			
			addChild(snow);
			watcher.watch(snow);
			
			var tw:Tween = new Tween(snow,"y", Regular.easeIn, 0, stage.stageHeight, time, true);
			tw.addEventListener(TweenEvent.MOTION_FINISH, function(event:TweenEvent)
			{
				event.target.removeEventListener(TweenEvent.MOTION_FINISH, arguments.callee);
				removeChild(snow);
			});
			
			info1Text.text = 'Watched: ' + watcher.numberOfLeftObjects + ' / ' + watcher.numberOfWatchedObjects;
			info2Text.text = '';
			info3Text.text = '';
		}
		
		private function onGarbageCollect(e:Event):void {
			info2Text.text = 'GC!';
		}

		private function onChange(e:Event):void {
			info3Text.text = 'Changed!';
		}
		
		private function clickHandler(event:MouseEvent):void
		{
			System.gc();
		}
	}
	
}